<template>
  <div>
    <v-card>
      <v-toolbar 
        color="secondary" 
        dark>
        <v-icon>business</v-icon>
        <v-toolbar-title 
          style="width: 150px" 
          class="ml-0 pl-3">
          <span class="hidden-sm-and-down">Jog</span>
        </v-toolbar-title>
      </v-toolbar>
    </v-card>
    <!-- section:custom_view -->
    <v-card>
      <!-- <jog></jog> -->
      <v-container 
        grid-list-md 
        text-xs-center>
        <!-- controls section -->
        <v-layout 
          row 
          wrap>
          <v-flex 
            xs12 
            md4>
                        
                            
            <jog 
              :feedrate="feedrate"
              :xystep="xystep"
              :zstep="zstep"
              :disabled="jog.disabled"
            />
            <v-container grid-list-md>
              <v-layout 
                row 
                wrap>
                <v-flex 
                  xs12 
                  md6>
                  <v-text-field 
                    v-model="xystep_"
                    label="XY step" 
                    suffix="mm"/>
                </v-flex>
                <v-flex 
                  xs12 
                  md6>
                  <v-text-field 
                    v-model="zstep_" 
                    label="Z step" 
                    suffix="mm"/>
                </v-flex>
              </v-layout>
              <v-layout row>
                <v-flex xs12>
                  <v-text-field 
                    v-model="feedrate_"
                    label="Feedrate" 
                    suffix="mm/s"/>
                </v-flex>
              </v-layout>
            </v-container>
          </v-flex>

          <v-flex 
            xs12 
            md3>
            <v-card>
              touch
            </v-card>
          </v-flex>

          <v-flex 
            xs12 
            md5>
                        
            <v-tabs>
              <v-tab>
                Temperature
              </v-tab>

              <v-tab>
                Extruder
              </v-tab>

              <v-tab-item>
                <v-container>
                  <v-layout 
                    row 
                    wrap>
                    <v-flex 
                      md3 
                      hidden-xs-only>
                      <!--    Degree Fahrenheit   &#8457; -->
                      <span><strong>Nozzle</strong><br>{{ temp.nozzle.current }}&#8451; / {{ temp.nozzle.target }}&#8451;</span>
                    </v-flex>

                    <v-flex 
                      xs12 
                      hidden-md-and-up>
                      <span><strong>Nozzle - </strong>{{ temp.nozzle.current }}&#8451; / {{ temp.nozzle.target }}&#8451;</span>
                    </v-flex>

                    <v-flex 
                      md9 
                      xs12>
                      <!-- <v-subheader class="pl-0">Bed</v-subheader> -->
                      <v-slider 
                        :max="250" 
                        :thumb-size="24" 
                        step="5" 
                        thumb-label="always"/>
                    </v-flex>
                  </v-layout>

                  <v-layout 
                    row 
                    wrap>
                    <v-flex 
                      md3 
                      hidden-xs-only>
                      <span><strong>Bed</strong><br>{{ temp.bed.current }}&#8451; / {{ temp.bed.target }}&#8451;</span>
                    </v-flex>

                    <v-flex 
                      xs12 
                      hidden-md-and-up>
                      <span><strong>Bed - </strong>{{ temp.bed.current }}&#8451; / {{ temp.bed.target }}&#8451;</span>
                    </v-flex>

                    <v-flex 
                      md9 
                      xs12>
                      <!-- <v-subheader class="pl-0">Bed</v-subheader> -->
                      <v-slider 
                        :max="100" 
                        :thumb-size="24" 
                        step="5" 
                        thumb-label="always"/>
                    </v-flex>
                  </v-layout>

                  <v-layout 
                    row 
                    wrap>
                    <v-flex 
                      md3 
                      hidden-xs-only>
                      <span><strong>Fan</strong><br>{{ fan.pwm }}%</span>
                    </v-flex>

                    <v-flex 
                      xs12 
                      hidden-md-and-up>
                      <span><strong>Fan - </strong>{{ fan.pwm }}%</span>
                    </v-flex>

                    <v-flex 
                      md9 
                      xs12>
                      <!-- <v-subheader class="pl-0">Bed</v-subheader> -->
                      <v-slider 
                        :max="100" 
                        :thumb-size="24" 
                        step="5" 
                        thumb-label="always"/>
                    </v-flex>
                  </v-layout>
                                    
                </v-container>
              </v-tab-item>

              <v-tab-item>
                #2
              </v-tab-item>

            </v-tabs>

          </v-flex>
        </v-layout>

        <!-- terminal section -->
        <v-layout 
          row 
          wrap>
          <v-flex 
            xs12 
            md6>
            <v-card>
              <v-textarea
                name="input-7-1"
                value=""
                hint="> Write command"
                              

                no-resize
                              

              />
            </v-card>
          </v-flex>

          <v-flex 
            xs12 
            md6>
            <v-container 
              class="scroll-y" 
              style="max-height: 200px">
              <v-list 
                two-line 
                subheader 
                dense>
                <v-list-tile>
                  <v-list-tile-content>
                    <v-list-tile-title>M114</v-list-tile-title>
                    <v-list-tile-sub-title>X:0 Y:0 Z:0 Count</v-list-tile-sub-title>
                  </v-list-tile-content>
                </v-list-tile>
                <v-list-tile>
                  <v-list-tile-content>
                    <v-list-tile-title>M114</v-list-tile-title>
                    <v-list-tile-sub-title>X:0 Y:0 Z:0 Count</v-list-tile-sub-title>
                  </v-list-tile-content>
                </v-list-tile>
                <v-list-tile>
                  <v-list-tile-content>
                    <v-list-tile-title>M114</v-list-tile-title>
                    <v-list-tile-sub-title>X:0 Y:0 Z:0 Count</v-list-tile-sub-title>
                  </v-list-tile-content>
                </v-list-tile>
                <v-list-tile>
                  <v-list-tile-content>
                    <v-list-tile-title>M114</v-list-tile-title>
                    <v-list-tile-sub-title>X:0 Y:0 Z:0 Count</v-list-tile-sub-title>
                  </v-list-tile-content>
                </v-list-tile>
                <v-list-tile>
                  <v-list-tile-content>
                    <v-list-tile-title>M114</v-list-tile-title>
                    <v-list-tile-sub-title>X:0 Y:0 Z:0 Count</v-list-tile-sub-title>
                  </v-list-tile-content>
                </v-list-tile>
              </v-list>
            </v-container>
          </v-flex>
        </v-layout>
      </v-container>

    </v-card>
    <!-- endsection:custom_view -->
  </div>

</template>

<script>
// section:custom_imports
import Jog from './Components/Jog'
// endsection:custom_imports
		
import {bus} from '@js/bus'

export default {

	components: {
		// section:custom_components
		Jog
		// endsection:custom_components
	},

	data() {
		// section:custom_before_data
		// endsection:custom_before_data
		return {
			// section:custom_data
			feedrate_: 500,
			xystep_: 10,
			zstep_: 5,
			position: {
				x: 0,
				y: 0,
				z: 0,
			},
			homed: {
				x: false,
				y: false,
				z: false
			},
			absolute: {
				x: true,
				y: true,
				z: true,
				e: true
			},
			temp: {
				nozzle: {
					current: 25,
					target: 250
				},
				bed: {
					current: 25,
					target: 100
				}
			},
			fan: {
				pwm: 0
			},
			jog: {
				disabled: false
			}
			// endsection:custom_data
		}
	},

	computed: {
		// section:custom_computed
		feedrate() {
			var value = Number(this.feedrate_)
			if(value != NaN)
				return value
			return 500
		},

		xystep() {
			var value = Number(this.xystep_)
			if(value != NaN)
				return value
			return 10
		},

		zstep() {
			var value = Number(this.zstep_)
			if(value != NaN)
				return value
			return 5
		},
		// endsection:custom_computed
	},

	created() {
		bus.$on('jog-move', this.jogMove)
		//this.$wamp.call('jog.position.get', [])
		//this.$wamp.call('jog.position.set', [x,y,z])

		//this.$wamp.subscribe('gcode.state.change', ...)


	},

	beforeDestroy() {
		bus.$off('jog-move', this.jogMove)

		//this.$wamp.unsubscribe('gcode.state.change', ...)
	},

	methods: {
		// section:custom_methods
		jogMove(direction) {
			console.log('jog-move', direction)
			//this.$wamp.call('greeting', [])
			var gcode = ''
			switch(direction) {
			case 'up':
				gcode = 'G0Y-'+this.xystep+'F'+this.feedrate
				break
			case 'down':
				gcode = 'G0Y+'+this.xystep+'F'+this.feedrate
				break
			case 'right':
				gcode = 'G0X+'+this.xystep+'F'+this.feedrate
				break
			case 'left':
				gcode = 'G0X-'+this.xystep+'F'+this.feedrate
				break
			default:
				return
			}
			this.jog.disabled = true
			this.$wamp.call('gcode.send', [], {
				gcode: gcode
			})
				.then(result => {
					console.log('success', result)
          

					this.$wamp.call('gcode.send', [], {
						gcode: 'M400'
					})
						.then(result => {
							this.jog.disabled = false
						})
						.catch(error => {
							this.jog.disabled = false
						})

				})
				.catch(error => {
					console.error('fail', error)
					this.jog.disabled = false
				})
		},
		// endsection:custom_methods
	},
				

	// section:custom_extras
	/*wamp: {
						subscribe: {
								'some-topic': (args, kwArgs, details) => {

								}
						}
				}*/
	// endsection:custom_extras
}

</script>